<?php
// $Id: links.inc,v 1.1 2010/10/21 20:29:29 tomdude48 Exp $
function linkintel_node_links_page($node, $mode, $dir = 'out') {
  $where = array();
  $params = array($node->nid);
  if($dir == 'back') {
    drupal_set_title('Backlinks');
    $where[] = 'to_nid = %d';    
  }
  else {
    drupal_set_title('Links');
    $where[] = 'nid = %d';  
  }
 
  $header = array();  
  $header[] = array('data' => t('Text'), 'field' => 'atext');
  if($dir == 'back') {
    $header[] = array('data' => t('From'), 'field' => 'pid');    
  }
  else {
    $header[] = array('data' => t('To'), 'field' => 'r.href');
  }
  $header[] = array('data' => t('Mode'), 'field' => 'r.mode');
  $header[] = array('data' => t('Autogen'), 'field' => 'r.autogen');
  $header[] = array('data' => t('Nofollow'), 'field' => 'r.nofollow');
  $header[] = array('data' => t('Ops'));

  $sql = "
    SELECT l.*, IF(l.external, l.href, IF(l.nid > 0, l.nid, l.path)) AS pid, IF(l.to_external, l.href, IF(l.to_nid > 0, l.to_nid, l.path)) AS to_pid,  IF( l.text = '', k.keyword, l.text) AS atext
    FROM {linkintel_link} l
    LEFT JOIN {linkintel_keyword} k ON k.kid = l.kid
    " . (($where)? 'WHERE ':'') . implode(' AND ', $where)
  ;
  $tablesort = tablesort_sql($header);
  $sql = $sql . $tablesort;
  $result = pager_query($sql, 100, 0, NULL, $params);

  $linkmodes = linkintel_get_linkmode_options(TRUE);
  $dest = 'node/' . $node->nid . '/linkintel/' . (($dir == 'back') ? 'backlinks' : 'links');

  $rows = array();
  while ($r = db_fetch_object($result)) {
    $attributes = unserialize($r->attributes);
    if($r->mode) {
      $ops = l(t('edit'), 'admin/content/linkintel/link/edit/' . $r->lid, array('query' => 'destination=' . $dest));
      $ops .= ' | ' . l(t('delete'), 'admin/content/linkintel/link/delete/' . $r->lid, array('query' => 'destination=' . $dest));
    } else {
      if($dir == 'back') {
        $ops = l(t('edit'), 'node/' . $r->nid . '/edit', array('query' => 'destination=' . $dest));
      }
    }
    $options = array();

    if($dir == 'back') {
      if($r->external) {
        $options['absolute'] = TRUE; 
      }
      $url = ($r->pid > 0) ? 'node/' . $r->pid : $r->pid;
      $tofrom = l($url, $url, $options);
    } 
    else {
      if($r->to_external) {
        $options['absolute'] = TRUE; 
      }
      $tofrom = l($r->href, $r->href, $options);
    } 
    
    $row = array();
    $row[] = ($r->atext) ? check_plain($r->atext) : '[node_title]';
    $row[] = $tofrom;
    $row[] = $linkmodes[$r->mode];
    $row[] = ($r->autogen) ?  t('Y') : t('N');
    $row[] = ($r->nofollow) ?  t('Y') : t('N');    
    $row[] = $ops;
    
    $rows[] = array('data' =>
      $row,
      // Attributes for tr
      'class' => "linkintel"
    );
  }

  if (!$rows) {
    $rows[] = array(array('data' => t('No links were found.'), 'colspan' => count($header)));
  }  

  $output .= theme('table', $header, $rows, array('id' => 'linkintel-request'));
  $output .= theme('pager', NULL, 100, 0);
  
  $qa = '';
  if($mode == 'node') {
    $qa = (($dir == 'back') ? '&to_nid=' : '&nid=') . $node->nid;
  }
  $output .= l(t('Add link'), 'admin/content/linkintel/link/edit/', array('query' => 'destination=' . $dest . $qa));
  return $output; 
  
  
  return $output;
}

/**
 * Generates table of keywords associated with a pages
 * 
 * @param int|str|nodeobj $pid - page id; the nid (int) or path (str) of the page 
 */
function linkintel_links_page() {
  //drupal_set_title('Links');

  $filter = linkintel_links_build_filter_query();
//dsm($filter);

  $output .= drupal_get_form('linkintel_links_filter_form');
//dsm($filter);

  $header = array();
  $header[] = array('data' => t('Text'), 'field' => 'atext');
  $header[] = array('data' => t('From'), 'field' => 'pid');    
  $header[] = array('data' => t('To'), 'field' => 'r.href');
  $header[] = array('data' => t('Mode'), 'field' => 'r.mode');
  $header[] = array('data' => t('Autogen'), 'field' => 'r.autogen');
  $header[] = array('data' => t('Nofollow'), 'field' => 'r.nofollow');
  $header[] = array('data' => t('Request'), 'field' => 'r.rid');
  $header[] = array('data' => t('Ops'));
  
  $sql = "
    SELECT l.*, IF(l.nid > 0, l.nid, l.path) AS pid, IF(l.to_external, l.href, IF(l.to_nid > 0, l.to_nid, l.to_path)) AS to_pid,  IF( l.text = '', k.keyword, l.text) AS atext
    FROM {linkintel_link} l
    LEFT JOIN {linkintel_keyword} k ON k.kid = l.kid
  ";
  $tablesort = tablesort_sql($header);
  if (!empty($filter['where'])) {
    $sql = $sql ." WHERE " . $filter['where'] . $tablesort;
    $result = pager_query($sql, 100, 0, NULL, $filter['args']);
  }
  else {
    $result = pager_query($sql . $tablesort, 100);
  }

  $linkmodes = linkintel_get_linkmode_options(TRUE);
  $dest = 'admin/content/linkintel/links/' . $pid;
  $rows = array();
  while ($r = db_fetch_object($result)) {
    //$attributes = unserialize($r->attributes);
    $row = array();
    if($r->mode) {
      $ops = l(t('edit'), 'admin/content/linkintel/link/edit/' . $r->lid, array('query' => 'destination=' . $dest));
      $ops .= ' | ' . l(t('delete'), 'admin/content/linkintel/link/delete/' . $r->lid, array('query' => 'destination=' . $dest));
    } else {
      $ops = l(t('edit node'), 'node/' . $r->nid . '/edit', array('query' => 'destination=' . $dest));
    }
    $to_options = array();
    $from_options = array();
    if($r->to_external) {
      $to_options['absolute'] = TRUE;
    }
    if($r->external) {
      $from_options['absolute'] = TRUE;
    }
    $row[] = check_plain($r->atext);
    $row[] = ($r->pid > 0) ? l('node/' . $r->pid, 'node/' . $r->pid, $from_options) : l($r->pid, $r->pid, $from_options);
    $row[] = ($r->to_pid > 0) ? l('node/' . $r->to_pid, 'node/' . $r->to_pid, $to_options) : l($r->to_pid, $r->to_pid, $to_options);
    $row[] = $linkmodes[$r->mode];
    $row[] = ($r->autogen) ?  t('Y') : t('N');
    $row[] = ($r->nofollow) ?  t('Y') : t('N'); 
    $row[] = ($r->rid) ?  l($r->rid, 'admin/content/linkintel/request/edit/' . $r->rid, array('query' => 'destination=' . $dest)) : '-';    
    $row[] = $ops;
    
    $rows[] = array('data' =>
      $row,
      // Attributes for tr
      'class' => "linkintel"
    );
  }

  if (!$rows) {
    $rows[] = array(array('data' => t('No links were found.'), 'colspan' => count($header)));
  }  

  $output .= theme('table', $header, $rows, array('id' => 'linkintel-request'));
  $output .= theme('pager', NULL, 100, 0);
  
  //$output .= l(t('Add link'), 'admin/content/linkintel/link/edit/', array('query' => 'destination=' . $dest ));
  return $output;
}

function linkintel_links_build_filter_query() {
  if (empty($_SESSION['linkintel_links_filter'])) {
    return;
  }

  $filters = linkintel_links_filters();

  // Build query
  $where = $args = array();
//dsm($_SESSION['kwresearch_overview_filter']);
  foreach ($_SESSION['linkintel_links_filter'] as $key => $filter) {
//dsm("$key = $filter " . $filters[$key]['type']);
    if($key == 'like_match') {
      continue;
    }
    $filter_where = array();

    if ($filters[$key]['type'] == 'select') {
      if(($key == 'mode') && ($filter == 0)) {
        continue;
      }
      $where[] = $filters[$key]['where'];
      // fix options index bug
      if($key == 'mode') {        
        $args[] = $filter-1;
      }
      else {
        $args[] = $filter;
      }
    }
    elseif ($filter) {      
      if ($key == 'keywords') {        
        if($_SESSION['linkintel_links_filter']['like_match']) {
          $filter_where[] = $filters['like_match']['where'];
          // there are two of them
          $args[] = $filter;
          $args[] = $filter;
        }
        else {
          $keywords = explode(',', $filter);
          $placeholders = implode(',', array_fill(0, count($keywords), '"%s"'));
          $filter_where[] = str_replace('"%s"', $placeholders, $filters[$key]['where']);
          // got to double the inserts
          foreach($keywords AS $keyword) {
            $keyword = trim(strtolower($keyword));
            $args[] = $keyword;
          }
          foreach($keywords AS $keyword) {
            $keyword = trim(strtolower($keyword));
            $args[] = $keyword;
          }
        }
      }
      else if(($key == 'from') || ($key == 'to')) {
        // treat as nid input
        $a = explode('/', $filter);
        if(($a[0] == 'node' && is_numeric($a[1])) || ($filter > 0)) {
          $nid = (($a[0] == 'node' && is_numeric($a[1])))? $a[1] : $filter;
          $filter_where[] = ($key == 'to') ? 'to_nid = %d' : 'nid = %d';
          $args[] = $nid;
        }
        else {
          $filter_where[] = $filters[$key]['where'];
          $args[] = $filter;         
        }
      }
      else {
        $filter_where[] = $filters[$key]['where'];
        $args[] = $filter;
      }      
    }
    if (!empty($filter_where)) {
      $where[] = '('. implode(' OR ', $filter_where) .')';
    }
  }
  $where = !empty($where) ? implode(' AND ', $where) : '';

  return array(
    'where' => $where,
    'args' => $args,
  );
}

/**
 * Return form for site keyword list filters.
 *
 */
function linkintel_links_filter_form() {
  $session = &$_SESSION['linkintel_links_filter'];
  $session = is_array($session) ? $session : array();
  $filters = linkintel_links_filters();

  $form['filters'] = array(
    '#type' => 'fieldset',
    '#title' => t('Filter links'),
    '#theme' => 'dblog_filters',
    '#collapsible' => TRUE,
    '#collapsed' => empty($session),
  );
  foreach ($filters as $key => $filter) {
    if ($filter['type'] == 'textfield') {
      $form['filters']['status'][$key] = array(
        '#title' => $filter['title'],
        '#type' => 'textfield',
        '#size' => ($filter['size'])? $filter['size']:8,
      );    
    }
    elseif ($filter['type'] == 'select') {
      $form['filters']['status'][$key] = array(
        '#title' => $filter['title'],
        '#type' => 'select',
        '#options' => $filter['options'],
      );
    }
    elseif ($filter['type'] == 'checkbox') {
      $form['filters']['status'][$key] = array(
        '#title' => $filter['title'],
        '#type' => 'checkbox',
        '#return_value' => $filter['return_value'],
      );
    }
    elseif ($filter['type'] == 'markup') {
      $form['filters']['status'][$key] = array(
        '#type' => $filter['type'],
        '#value' => $filter['value'],
      );       
    }
    if (!empty($session[$key])) {
      $form['filters']['status'][$key]['#default_value'] = $session[$key];
    }
  }

  $form['filters']['buttons']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Filter'),
  );
  if (!empty($session)) {
    $form['filters']['buttons']['reset'] = array(
      '#type' => 'submit',
      '#value' => t('Reset')
    );
  }

  return $form;
}

/**
 * Returns filters for site keywords report
 */
function linkintel_links_filters() {
  $filters = array();

  $options = linkintel_get_linkmode_options();
  $filters['keywords'] = array(
    'title' => t('Keywords'),
    'type' => 'textfield',
    'size' => 60,
    'description' => t('Enter a comma seperated list of keywords to filter by exact match.'),
    'where' => 'k.keyword IN ("%s") OR l.text IN ("%s")',
  ); 
  $filters['like_match'] = array(
    'title' => t('Like match'),
    'type' => 'checkbox',
    'return_value' => 1,
    'where' => 'k.keyword LIKE "%%%s%%" OR l.text LIKE "%%%s%%"',
  );
  $filters['from'] = array(
    'title' => t('From'),
    'type' => 'textfield',
    'size' => 60,
    'where' => 'path = "%s"',
    'description' => t('Input a path or nid.'),
  );  
  $filters['to'] = array(
    'title' => t('To'),
    'type' => 'textfield',
    'size' => 60,
    'where' => 'href = "%s"',
    'description' => t('Input a path or nid.'),
  );
  $filters['external'] = array(
    'title' => t('From external'),
    'type' => 'checkbox',
    'return_value' => 1,
    'where' => 'l.external = %d',
  ); 
  $filters['to_external'] = array(
    'title' => t('To external'),
    'type' => 'checkbox',
    'return_value' => 1,
    'where' => 'l.to_external = %d',
  ); 

  $options = array(0 => t('All'));
  $options = array_merge($options, linkintel_get_linkmode_options());
  //foreach(linkintel_get_linkmode_options() AS $k => $v) {
  //  $options[$k] = $v;
  //}
  $filters['mode'] = array(
    'title' => t('Mode'),
    'type' => 'select',
    'options' => $options,
    'where' => 'l.mode = %d',
  ); 
  $filters['autogen'] = array(
    'title' => t('Auto Generated'),
    'type' => 'checkbox',
    'return_value' => 1,
    'where' => 'l.autogen = %d',
  ); 
  $filters['nofollow'] = array(
    'title' => t('Nofollow'),
    'type' => 'checkbox',
    'return_value' => 1,
    'where' => 'l.nofollow = %d',
  );
  return $filters;
}

/**
 * Validate result from site keyword report filter form.
 */
function linkintel_links_filter_form_validate($form, &$form_state) {
  if ($form_state['values']['op'] == t('Filter') 
    && empty($form_state['values']['keywords'])
    && empty($form_state['values']['from']) 
    && empty($form_state['values']['to'])
    && empty($form_state['values']['external'])
    && empty($form_state['values']['to_external'])
    && ($form_state['values']['mode'] == 0)
    && empty($form_state['values']['autogen'])
    && empty($form_state['values']['nofollow'])
  ) {
    form_set_error('type', t('You must select something to filter by.'));
  }
}

/**
 * Process result from site keywords report filter form.
 */
function linkintel_links_filter_form_submit($form, &$form_state) {
  $op = $form_state['values']['op'];
  $filters = linkintel_links_filters();
  switch ($op) {
    case t('Filter'):
      foreach ($filters as $name => $filter) {
        if (isset($form_state['values'][$name])) {
          $_SESSION['linkintel_links_filter'][$name] = $form_state['values'][$name];
        }
      }
      break;
    case t('Reset'):
      $_SESSION['linkintel_links_filter'] = array();
      break;
  }
  return 'admin/content/linkintel/links';
}

/**
 * Generages page keyword edit form
 * 
 * @param int|str $pid - page id; the nid (int) or path (str) of the page
 * @param int $kid - keyword id
 */
function linkintel_link_edit_page($lid = '') {
  if($lid > 0) {
    $link_obj = linkintel_load_link($lid);
  }
  if ($link_obj->lid) {
    drupal_set_title(t('Edit link'));
  }
  else {
    drupal_set_title(t('Add link'));
    $link_obj = new stdClass();
    if($_GET['nid']) {
      $link_obj->nid = $_GET['nid'];
    }
    if($_GET['rid']) {
      $request = linkintel_load_request($_GET['rid']);
      $link_obj->text = $request->keyword;
      $link_obj->keyword = $request->keyword;
      $link_obj->kid = $request->kid;
      $link_obj->href = $request->path;
      $link_obj->to_nid = $request->nid;
      $link_obj->mode = ($link_obj->keyword) ? 1 : 2;
      if(is_array($link_obj->attributes)) {
        foreach($link_obj->attributes AS $attr => $v) {
          $link_obj->attributes[$attr] = $v;
        }
      }
    }
  }  
  $output .= drupal_get_form('linkintel_link_edit_form', $link_obj);
  return $output;
}

/**
 * Returns page keyword edit form
 * 
 * @param arr $form_state
 * @param int|str $pid - page id; the nid (int) or path (str) of the page
 * @param str $keyword
 */

function linkintel_link_edit_form($form_state, $link_obj = stdClass) {
dsm($link_obj);  
  $form['lid'] = array(
    '#type' => 'value',
    '#value' => ($link_obj->lid) ? $link_obj->lid : ''
  );
  if($link_obj->nid || $link_obj->path) {
    $url0 = ($link_obj->path) ? $link_obj->path : 'node/' . $link_obj->nid;
    $url1 = url($url0);
    $form['page'] = array(
        '#title' => t('Page'),
        '#type' => 'item',
        '#value' =>  l($url1, $url0),
    );
    $form['nid'] = array(
      '#type' => 'value',
      '#value' => $link_obj->nid
    );
    $form['path'] = array(
      '#type' => 'value',
      '#value' => $link_obj->path
    );
  }
  else {
    $form['nid'] = array(
      '#type' => 'textfield',
      '#title' => t('Node id'),
      '#size' => 8, 
      '#required' => TRUE,
      '#description' => t('Enter the nid you want to associate this request.'),
    );    
  }
  $options = linkintel_get_linkmode_options();
  $form['mode'] = array(
    '#type' => 'select',
    '#title' => t('Mode'), 
    '#options' => $options,
    '#required' => TRUE,
    '#default_value' => ($link_obj->mode) ? $link_obj->mode:2,
    '#description' => t('Determines where the link will be displayed: 
      <ul>
        <li><em>Inline</em> - searches the content for the anchor text and if found wraps the anchor text with the link. If not found, link is not displayed.</li>
        <li><em>Sidebar</em> - included in the sidebar links.</li>
      </ul>
    '),
  );
  
  $form['href'] = array(
    '#type' => 'textfield',
    '#title' => t('URL path'),
    '#default_value' => $link_obj->href,
    '#required' => TRUE,
    '#description' => t('The url you want to link to. This can be an internal Drupal path such as node/add or an external URL such as http://drupal.org. Enter &lt;front&gt; to link to the front page.'),
  ); 
  
  $form['anchortext'] = array(
    '#type' => 'textfield',
    '#title' => t('Anchor text'), 
    '#default_value' => $link_obj->text,
    '#description' => t('Anchor text is the clickable text of a hyperlink. For <em>coded</em> or <em>keyword</em> mode link, this is the keyword that get converted to a link therefor it must exist in the node body. For sidebar links, this is the clickable text. For sidebar links that link to another node, this can be left blank and the linked to node title will be used.'),
  ); 
  
  $form['attributes'] = array(
    '#type' => 'fieldset',      
    '#title' => t('Attributes'),      
    '#collapsible' => TRUE,      
    '#collapsed' => FALSE,    
  );
  $attributes = linkintel_get_link_attributes();
//dsm($link_obj);
  foreach($attributes AS $attr => $lable) {
    $form['attributes'][$attr] = array(
      '#type' => 'textfield',
      '#title' => $lable,
      '#default_value' => $link_obj->attributes[$attr],
    ); 
  }
  $form['attributes']['rel']['#type'] = 'checkbox';
  $form['attributes']['rel']['#return_value'] = 'nofollow';
  
    
  $form['save'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
  );
  
  return $form;
}

/**
 * Validates the page keyword edit form
 * 
 * @param $form
 * @param $form_state
 */
function linkintel_link_edit_form_validate($form, &$form_state) {
  $node = node_load($form_state['values']['nid']);
  if(!$node->nid) {
    form_set_error('nid', t('A node does not exist for the nid. Please provide a valid nid'));
  }
  if($form_state['values']['mode'] == 0 || $form_state['values']['mode'] == 1) {
    if(!strlen($form_state['values']['anchortext'])) {
      form_set_error('anchortext', t('Anchor text is required for <em>coded</em> and <em>keyword</em> mode type links.'));
    }
    $link = new stdClass();
    $link->text = $form_state['values']['anchortext'];
    $regex = linkintel_get_regex_for_link($link);
    preg_match($regex, $node->body, $found);
    if(!count($found)) {
      form_set_error('anchortext', t('The phrase "@phrase" was not found in the body of node !node. Please select a phrase that exists in the node body.',
        array(
          '@phrase' => $form_state['values']['anchortext'],
          '!node' => l('node/' . $node->nid, 'node/' . $node->nid),
        )
      ));
    }
  }
  $link = linkintel_validate_link($form_state['values']['href']);
  if(!$link) {
    form_set_error('href', t("The path '@link_path' is either invalid or you do not have access to it.", array('@link_path' => $item['link_path'])));
  }
  $node_link = FALSE;
  if(!$link['external']) {
    $args = explode('/', $link['normal_path']);
    if($args[0] == 'node' && is_numeric($args[1])) {
      $node_link = TRUE;
    }
  }
  if(!$node_link && !strlen($form_state['values']['anchortext'])) {
    form_set_error('anchortext', t("You must set the anchor text for any link that does not link to a node."));
  }
}

/**
 * Processes the page keyword edit form
 * 
 * @param $form
 * @param $form_state
 */
function linkintel_link_edit_form_submit($form, &$form_state) {
dsm($form_state['values']);
  $link_obj = new stdClass();
  $link_obj->lid = $form_state['values']['lid'];
  $link_obj->nid = $form_state['values']['nid'];
  $link_obj->uid = $_GLOBALS['user']->uid;
  $link_obj->mode = $form_state['values']['mode'];
  if($link_obj->mode == 0 || $link_obj->mode == 1) {
    $link_obj->keyword = $form_state['values']['anchortext'];
  }
  $link_obj->text = $form_state['values']['anchortext'];
  $link_obj->href = $form_state['values']['href'];
  
  $link_obj->autogen = 0;  
  
  $link_obj->attributes = array();
  $attributes = linkintel_get_link_attributes();
  foreach($attributes AS $attr => $lable) {
    if($form_state['values'][$attr]) {
        $link_obj->attributes[$attr] = $form_state['values'][$attr];
    }
  }
  
  linkintel_save_link($link_obj);
  
  drupal_set_message(t('A link was saved for nid <em>@nid</em> and keyword <em>@keyword</em>.', 
    array(
      '@nid' => $link_obj->nid,
      '@keyword' => $link_obj->keyword
    )),
    'status'
  );
}

function linkintel_link_delete_page($lid) {
  drupal_set_title(t('Delete link'));
  $link = linkintel_load_link($lid);
  if(!$link->lid) {
    drupal_set_message(t('A link with ID @id was not found.', array('@id' => $link->lid)), 'error');
    return '';
  }
  if($link->mode == 0) {
    drupal_set_message(t('The link you are trying to delete is coded into content. You must remove coded links directly from the content. !link.', 
      array(
        '!link' => l(t('Edit content'), 'node/' . $link->nid),
      )), 
      'error');
    return '';
  }
  $output .= drupal_get_form('linkintel_link_delete_form', $link);
  return $output;
}

/**
 * Generages page keyword edit form
 * 
 * @param int|str $pid - page id; the nid (int) or path (str) of the page
 * @param int $kid - keyword id
 */
function linkintel_link_delete_form($form_state, $link) {
dsm($link);
  $form['message'] = array(
  '#type' => 'markup',
  '#value' => t('Are you sure you want to delete the link <em>!link</em> on page <em>!page</em>?',
      array(
        '!link' => l($link->text, $link->href),
        '!page' => l($link->path, $link->path),
      )
    ),
  );
  
  $form['lid'] = array(
    '#type' => 'value',
    '#value' => $link->lid,
  );
  
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Delete'),
  );
  $form['cancel'] = array(
      '#type' => 'markup',
      '#value' => l(t('Cancel'), $_GET['destination']),
  );
  
  return $form;
}

function linkintel_link_delete_form_submit($form, &$form_state) {

  $link = linkintel_load_link($form_state['values']['lid']);

  linkintel_delete_link($link);
  
  drupal_set_message(t('The link <em>!link</em> was deleted on page <em>!page</em>?',
    array(
      '!link' => l($link->text, $link->href),
      '!page' => l($link->path, $link->path),
     )),
    'status'
  );
}
