<?php
// $Id: suggestions.inc,v 1.1 2010/10/21 20:29:29 tomdude48 Exp $


function linkintel_node_suggestions_page($node, $mode, $keywords = '') {
  drupal_set_title('Suggestions');
  $kwresearch_exists = module_exists('kwresearch');
  $filter = linkintel_node_suggestions_build_query($node);
//dsm($filter); 

  $output .= drupal_get_form('linkintel_node_suggestions_form');

  // no data to present
  if(empty($filter)) {
    return $output;
  }
  
  $header = array();
  $header[] = array('data' => t('Keyword'), 'field' => 'k.keyword');
  $header[] = array('data' => t('To'), 'field' => 'pid');
  $header[] = array('data' => t('Score'), 'field' => 'score', 'sort' => 'desc');
  $header[] = array('data' => t('Request'), 'field' => 'r.priority');
  $header[] = array('data' => t('Page'), 'field' => 'p.priority');
  if(module_exists('kwresearch')) {
    $header[] = array('data' => t('Keyword'), 'field' => 'keyword_priority'); 
  }  
  $header[] = array('data' => t('Title'));
  $header[] = array('data' => t('Ops'));
  
  if($rand) {
    $rand_sql = linkintel_get_autogen_rand_sql();
  }
  if($kwresearch_exists) {
    $div = ($rand_sql) ? 62500 : 1250;
    $select = "kwr.kid AS kwr_kid, kwr.priority AS keyword_priority, (r.priority * IF(p.priority >= 0, p.priority, 50) * IF(kwr.priority >= 0, kwr.priority, 50) $rand_sql / $div) AS score";
    $join = "LEFT JOIN {kwresearch_keyword} kwr ON kwr.keyword = k.keyword";
  }
  else {
    $div = ($rand_sql) ? 1250 : 25;
    $select = "(r.priority * IF(p.priority >= 0, p.priority, $rand_sql / $div) AS score";
  }
  
  $sql = "
    SELECT r.*, IF(r.nid > 0, r.nid, r.path) AS pid, k.keyword, p.priority AS page_priority, 
    $select
    FROM {linkintel_request} r
    JOIN {linkintel_keyword} k ON k.kid = r.kid
    LEFT JOIN {node} n ON r.nid = n.nid
    LEFT JOIN {linkintel_page} p ON p.nid = r.nid 
    $join
  ";
  $tablesort = tablesort_sql($header);
  if (!empty($filter['where'])) {
    $sql = $sql ." WHERE " . $filter['where'] . $tablesort;
    $result = pager_query($sql, 100, 0, NULL, $filter['args']);
  }
  else {
    $result = pager_query($sql . $tablesort, 100, $filter['args']);
  }
//dsm(sprintf($sql,$filter['args'] ));

  $priorities = linkintel_get_priority_options();
  $dest = 'node/' . $node->nid . '/linkintel/requests';
  $rows = array();
  while ($r = db_fetch_object($result)) {
    $attributes = unserialize($r->attributes);
    $ops = l(t('add link'), 'admin/content/linkintel/link/edit', array('query' => 'destination=' . $dest . '&rid=' . $r->rid . '&nid=' . $node->nid));
    $row = array();
    $row[] = check_plain($r->keyword);
    $options = array();
    if($r->external) {
      $options['absolute'] = TRUE; 
    }
    $url = ($r->pid > 0) ? 'node/' . $r->pid : $r->pid;
    $row[] = l($url, $url, $options);
    $row[] = number_format($r->score);
    $t = ($priorities[$r->priority]) ? $priorities[$r->priority] : $r->priority;
    $row[] = l($t, 'admin/content/linkintel/request/edit/' . $r->rid, array('query' => 'destination=' . $dest));
    
    $t = ($priorities[$r->page_priority]) ? $priorities[$r->page_priority] : $r->page_priority;
    $row[] = l($t, 'node/' . $r->nid . '/edit', array('query' => 'destination=' . $dest));
    if($kwresearch_exists) {
      $t = ($priorities[$r->keyword_priority]) ? $priorities[$r->keyword_priority] : (($r->keyword_priority >= 0) ? $r->keyword_priority : '-');
      $row[] = l($t, 'admin/content/kwresearch/keyword_list/edit/' . $r->kwr_kid, array('query' => 'destination=' . $dest));
    } 
    $row[] = ($attributes['title']) ?  $attributes['title'] : '[node title]';
    $row[] = $ops;
    
    $rows[] = array('data' =>
      $row,
      // Attributes for tr
      'class' => "linkintel"
    );
  }

  if (!$rows) {
    $rows[] = array(array('data' => t('No request were found.'), 'colspan' => count($header)));
  }  

  $output .= theme('table', $header, $rows, array('id' => 'linkintel-request'));
  $output .= theme('pager', NULL, 100, 0);
  
  //$output .= l(t('Add request'), 'admin/content/linkintel/request/edit/', array('query' => 'destination=' . $dest . '&nid=' . $node->nid));
  
  unset($_SESSION['linkintel_node_suggestions_form']);
  return $output;
}

function linkintel_node_suggestions_build_query($node) {
  $data = $_SESSION['linkintel_node_suggestions_filter'];
  if(is_array($_SESSION['linkintel_node_suggestions_form'])) {
    foreach($_SESSION['linkintel_node_suggestions_form'] AS $k => $v) {
      $data[$k] = $v;
    }
  }
  if (empty($data)) {
    return;
  }
//dsm($data);
  
  $filters = linkintel_node_suggestions_filters();
//dsm($filters);
  // Build query
  $where = $args = array();
  
  // don't suggest links to self and pages already linked to
  $not_in_nids = array($node->nid);
  if($links0 = linkintel_load_links_by_page($node->nid)) {
    foreach($links0 AS $l) {
      $not_in_nids[] = $l->nid;
    }
  }
  $placeholders = implode(',', array_fill(0, count($not_in_nids), '%d'));
  $where[] = "r.nid NOT IN($placeholders)";
  $args[] = $not_in_nids;
//dsm($_SESSION['kwresearch_overview_filter']);
  foreach ($data as $key => $filter) {
//dsm("$key = $filter " . $filters[$key]['type']);
    if(!$filters[$key]['#where']) {
      continue;
    }
    if($key == 'like_match') {
      continue;
    }
    $filter_where = array();
    if ($filters[$key]['#type'] == 'select') {
      foreach ($filter as $value) {
        $filter_where[] = $filters[$key]['#where'];
        $args[] = $value;
      }
    }
    elseif ($filter) {      
      if ($key == 'keywords') {        
        if($_SESSION['linkintel_requests_filter']['like_match']) {
          $filter_where[] = $filters['like_match']['#where'];
          $args[] = $filter;
        }
        else {
          $keywords = explode(',', $filter);
          $placeholders = implode(',', array_fill(0, count($keywords), '"%s"'));
          $filter_where[] = str_replace('"%s"', $placeholders, $filters[$key]['#where']);
          foreach($keywords AS $keyword) {
            $keyword = trim(strtolower($keyword));
            $args[] = $keyword;
          }
        }
      }
      else if($key == 'from') {
        // treat as nid input
        $a = explode('/', $filter);
        if(($a[0] == 'node' && is_numeric($a[1])) || ($filter > 0)) {
          $nid = (($a[0] == 'node' && is_numeric($a[1])))? $a[1] : $filter;
          $filter_where[] = 'r.nid = %d';
          $args[] = $nid;
        }
        else {
          $filter_where[] = $filters[$key]['#where'];
          $args[] = $filter;         
        }
      }
      else {
        $filter_where[] = $filters[$key]['#where'];
        $args[] = $filter;
      }      
    }
    if (!empty($filter_where)) {
      $where[] = '('. implode(' OR ', $filter_where) .')';
    }
  }
  $where = !empty($where) ? implode(' AND ', $where) : '';

  return array(
    'where' => $where,
    'args' => $args,
  );
}

function linkintel_node_suggestions_form() {
  $session_filter = &$_SESSION['linkintel_node_suggestions_filter'];
  $session_filter = is_array($session_filter) ? $session_filter : array();
  
  $session_form = $_SESSION['linkintel_node_suggestions_form'];
  $session_form = is_array($session_form) ? $session_form : array();
//dsm($session_filter);
//dsm($session_form);

  $nid = arg(1);
  $form['nid'] = array(
    '#type' => 'value',
    '#value' => arg(1),    
  );
  $keywords = $session_form['keywords'];
  if(!$keywords) {
    $keywords = linkintel_get_seed_keywords($nid);
    $keywords = implode(', ', $keywords);
  }
  $form['keywords'] = array(
    '#type' => 'textfield',
    '#title' => t('Keywords'),
    '#default_value' => ($analysis && $analysis['inputs']['keyword'])?$analysis['inputs']['keyword']:'',
    '#description' => t('Seperate keywords with commas, e.g. "keyword,keyphrase,key word"'),
    '#default_value' => $keywords,
    '#size' => 120,
    '#maxlength' => 1024,
    '#where' => 'k.keyword IN ("%s")',
  );
  
  $form['options'] = array(
    '#type' => 'fieldset',
    '#title' => t('Options'),
    //'#theme' => 'dblog_filters',
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    //'#collapsed' => empty($session_filter),
  );
  
  $form['options']['like_match'] = array(
    '#type' => 'checkbox',  
    '#title' => t('Like match'),    
    '#return_value' => 1,
    '#default_value' => $session_filter['like_match'],
    '#where' => 'k.keyword LIKE "%%%s%%"',
    '#filter' => 1,
  );
  
  $options = linkintel_get_priority_options();
  $form['options']['request_priority'] = array(
    '#type' => 'select',  
    '#title' => t('Request priority'),    
    '#options' => $options,
    '#multiple' => TRUE,
    '#default_value' => $session_filter['request_priority'],
    '#where' => 'r.priority = %d',
    '#filter' => 1,
  );
  $form['options']['page_priority'] = array(
    '#type' => 'select',  
    '#title' => t('Page priority'),    
    '#options' => $options,
    '#multiple' => TRUE,
    '#default_value' => $session_filter['page_priority'],
    '#where' => 'p.priority = %d',
    '#filter' => 1,
  );
  $form['options']['keyword_priority'] = array(
    '#type' => 'select',  
    '#title' => t('Page priority'),    
    '#options' => $options,
    '#multiple' => TRUE,
    '#default_value' => $session_filter['keyword_priority'],
    '#where' => 'kwr.priority = %d',
    '#filter' => 1,
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
  );
  if (!empty($session)) {
    $form['reset'] = array(
      '#type' => 'submit',
      '#value' => t('Reset')
    );
  }

  return $form;
}

function linkintel_node_suggestions_filters() {
  $form = linkintel_node_suggestions_form();
  $filters = linkintel_flatten_form($form);
  return $filters;   
}

function linkintel_flatten_form($form) {
  $ret = array();
  // get field sets
  foreach($form AS $k => $v) {
    if($v['#type'] == 'fieldset') {
      foreach($v AS $k2 => $v2) {
        if(substr($k2, 0, 1) != '#') {
          $ret[$k2] = $v2;
        }
      }
    }
    else {
      $ret[$k] = $v;
    }
  }
  return $ret;
}

/**
 * Validate result from site keyword report filter form.
 */
function linkintel_node_suggestions_form_validate($form, &$form_state) {

}

/**
 * Process result from site keywords report filter form.
 */
function linkintel_node_suggestions_form_submit($form, &$form_state) {
  $op = $form_state['values']['op'];
  $filters = linkintel_node_suggestions_filters();
//dsm($filters);
  switch ($op) {
    case t('Submit'):
      foreach ($filters as $name => $filter) {
        if (isset($form_state['values'][$name])) {
          if($filters[$name]['#filter']) {
            $_SESSION['linkintel_node_suggestions_filter'][$name] = $form_state['values'][$name];            
          } 
          else {
            $_SESSION['linkintel_node_suggestions_form'][$name] = $form_state['values'][$name];
          }
        }
      }
      break;
    case t('Reset'):
      $_SESSION['linkintel_node_suggestions_filter'] = array();
      break;
  }
//dsm($_SESSION['linkintel_node_suggestions_form']);
//dsm($_SESSION['linkintel_node_suggestions_filter']);
  return 'node/' . $form_state['values']['nid'] . '/linkintel/suggestions';
}

function linkintel_get_seed_keywords($nid) {
  $node = node_load($nid);
  $seeds = array();
  // seed using taxonomy
  if ($seed_vid = variable_get('linkintel_suggestions_seed_vocabulary', 0)) {
    $seeds = array();
    if($seed_vid) {
      foreach($node->taxonomy AS $term) {
        if($term->vid == $seed_vid) {
          $seeds[] = trim(strtolower($term->name));      
        }
      }
    } 
  }
  //seed using alchemy 
  if(module_exists('alchemy') && variable_get('linkintel_suggestions_seed_alchemy_enabled', 1)) {
    $types = variable_get('linkintel_suggestions_seed_alchemy_types', alchemy_get_types(TRUE));
    $thres = variable_get('linkintel_suggestions_seed_alchemy_threshold', 50) / 100;
    foreach($types AS $type) {
      $t = alchemy_get_elements($node->body, $type, 'normalized', $nid, ALCHEMY_DEBUG);
      if(is_array($t)) {
        foreach($t as $k => $v) {
          if($v['relevance'] >= $thresh) {
            $seeds[] = $k;
          }
        }      
      }
    }
  }
  
  drupal_alter('linkintel_get_seed_keywords', $seeds);
  
  return $seeds; 
}